﻿--[[
        Give Me Healthstone:
                Copyright 2009 by MERK, Mileg
				Updated by Grimgrin
                based on code by Mileg and Stephen Blaising
                
]]

GMHStone_ADDONNAME = "Give Me Healthstone";
GMHStone_MACRONAME = "GMHStone";

GMHStone_VERSION = "4.4.4";

CONJHS = "";
CONJHS2 = "";
HSIcon = 952;

function GMHStone_OnLoad()

  SlashCmdList["GIVEMEHSTONECOMMAND"] = GMHStone_SlashHandler;
  SLASH_GIVEMEHSTONECOMMAND1 = "/givemehealthstone";
  SLASH_GIVEMEHSTONECOMMAND2 = "/gmhstone";
  SLASH_GIVEMEHSTONECOMMAND3 = "/gmhs";
end

function GMHStone_OnEvent(event)
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMHStone_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMHStone_MACRONAME, HSIcon, "", nil, nil)
      else
        GMHStone_Print("You have 36 General Macros. Cannot add "..GMHStone_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(CHS)) then
      CONJHS = "[button:2] "..CHS.."; ";
      CONJHS2 = "[] "..CHS.."; ";
    else
      CONJHS = "";
    end
GMHStone_MakeArray();
    GMHStone_Go();
  elseif (event == "BAG_UPDATE") then
    GMHStone_MakeArray();
    GMHStone_Go();
  end
end

function GMHStone_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMHStone_Print(GMHStone_ADDONNAME.." |cff3399CCv"..GMHStone_VERSION.." ");
    GMHStone_Print("Type /macro to open macro list.");
    GMHStone_Print("Drag GMHStone macro to your action bar.");
    GMHealth_Print("This macro has two purposes.");
    GMHealth_Print("Left click to use best Healthstone.");
    GMHealth_Print("Warlocks can right click to \"Create Healthstone\".");
  end
end

function GMHStone_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMHStone_MakeArray()
  GMHStone_Healthstones = {

    [ 1] = { [1] = HS,  [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
  }
end

function GMHStone_Go()
  
  local HStoneRank = 0;
  local HStoneItemNum = 0;
  
  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMHStone_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, table.getn(GMHStone_Healthstones), 1 do
            if (GMHStone_Healthstones[index][1] == itemNumber) then
              if (GMHStone_Healthstones[index][2] <= UnitLevel("player")) then
                if (index > HStoneRank) then    
                  HStoneRank = index;
                  HStoneItemNum = itemNumber;
                end
              end
            end
          end
        end
      end
    end
  end
  
  if (HStoneRank > 0) then
    EditMacro(GMHStone_MACRONAME, GMHStone_MACRONAME, 1, "#showtooltip\n/use "..CONJHS.."item:"..HStoneItemNum, nil, nil);
  elseif (HStoneRank == 0) then
    EditMacro(GMHStone_MACRONAME, GMHStone_MACRONAME, HSIcon, "/use "..CONJHS2, nil, nil);
  end
end

function GMHStone_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
